package src;

import java.util.ArrayList;

/**
 *
 * @author fco.dominguez
 * @author juan.alvarez
 */

public class Jugador {

    private int tropasReserva = 0;
    private ArrayList<Dado> dadoAta;
    private ArrayList<Dado> dadoDef;
    
    private int numCambios;
    
    private Dado dadoComienzo;
    
    private int tropasGanadas;
    
    private boolean neutral = false;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C3251450-2ACF-9FDE-FD44-064F10A6DC9A]
    // </editor-fold> 
    private ArrayList<CartaTerritorio> cartaTerritorio;
    
    private ArrayList<Territorio> capitales;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EB29420D-54E2-B10D-5245-11C691C85A54]
    // </editor-fold> 
    private CartaMision cartaMision;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.893C4933-EA65-FCEF-006E-9EAB7A84C0F7]
    // </editor-fold> 
    private ArrayList<Territorio> territoriosJug;//array que contiene los territorios que posee el jugador

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C329B342-EB10-CE5B-11F2-2412EAF73E33]
    // </editor-fold> 
    //array que contiene los contienetes que posee el jugador, valido para ver los 
    //bonus de tropas que recibira el jugar en cada ronda
    private ArrayList<Continente> continenteJug;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3545A043-7A94-1C04-9A6B-4208B60EB890]
    // </editor-fold> 
    private String nombreJugador;//nombre del jugador

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8F51A544-89C6-951A-45C6-F1815BEDED91]
    // </editor-fold> 
    private int color;//color que defenira las tropas del jugador


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BE1AAF6B-AFB4-E588-49A8-D531F7DF5C24]
    // </editor-fold> 
    public Jugador(String nombre, int col) {
        setNombreJugador(nombre);
        setColor(col);
        territoriosJug = new ArrayList();
        cartaTerritorio = new ArrayList();
        continenteJug = new ArrayList();
        numCambios = 0;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1AF8609D-0A28-F131-FA56-163684E7795F]
    // </editor-fold> 
    public int getColor() {
        return color;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E63EED10-2194-FC3A-3041-60646C96C17C]
    // </editor-fold> 
    public void setColor(int val) {
        color = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F20D13F1-E7BE-555C-A366-C682CD6A9EC2]
    // </editor-fold> 
    public CartaMision getCartaMision() {
        return cartaMision;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0115132D-0EDF-1CB5-0762-5C3D99A1F0BF]
    // </editor-fold> 
    public void setCartaMision(CartaMision val) {
        cartaMision = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7512B379-52D7-60E6-CF9C-AB4348008272]
    // </editor-fold> 
    public ArrayList<CartaTerritorio> getCartaTerritorio() {
        return cartaTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.25D56166-A9F5-713E-A010-FCF5A2A22255]
    // </editor-fold> 
    public void setCartaTerritorio(ArrayList<CartaTerritorio> val) {
        cartaTerritorio = val;
    }
    
    public void anadirCartaTer(CartaTerritorio carta){
        cartaTerritorio.add(carta);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.005CB12A-15C1-A321-A429-A2128F358DD3]
    // </editor-fold> 
    public ArrayList<Continente> getContinente() {
        return continenteJug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D34124EF-B764-8739-D076-C99E40F3D767]
    // </editor-fold> 
    public void setContinente(ArrayList<Continente> val) {
        continenteJug = val;
    }
    
    public void anadirCont(Continente val){
        continenteJug.add(val);
    }
    
    public void quitarCont(Continente val){
        continenteJug.remove(val);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1D450EB5-75B3-D41C-DDDB-4E7C51DF7372]
    // </editor-fold> 
    public ArrayList<Territorio> getTerritorio() {
        return territoriosJug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.33DAD825-320C-3943-3957-F1A8A0BDB99E]
    // </editor-fold> 
    public void setTerritorio(ArrayList<Territorio> val) {
        territoriosJug = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D5B98F11-8D73-533E-4682-AF96F2E155F5]
    // </editor-fold> 
    public String getNombreJugador() {
        return nombreJugador;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CBEF3E8F-4EF4-5F7E-4823-AD96FAA9D959]
    // </editor-fold> 
    public void setNombreJugador(String val) {
        nombreJugador = val;
    }
    
    //cambia las cartas por tropas
    public boolean cambiarCartas(CartaTerritorio car1, CartaTerritorio car2, CartaTerritorio car3){
        boolean cambioCorrecto = false;
        
        //si la carta 1 es un comodin
        if (car1.getNumEjercitos() == 0){
            //si las otras son del mismo tipo
            if (car2.getNumEjercitos() == car3.getNumEjercitos()){
                cambioCorrecto = true;
            }
        }
        //si la carta 2 es un comodin
        else if (car2.getNumEjercitos() == 0){
            //si las otras son del mismo tipo
            if (car1.getNumEjercitos() == car3.getNumEjercitos()){
                cambioCorrecto = true;
            }
        }
        //si la carta 3 es un comodin
        else if (car3.getNumEjercitos() == 0){
            //si las otras son del mismo tipo
            if (car2.getNumEjercitos() == car1.getNumEjercitos()){
                cambioCorrecto = true;
            }
        }
        //o si las 3 son iguales
        else if ((car1.getNumEjercitos() == car2.getNumEjercitos()) && (car2.getNumEjercitos() == car3.getNumEjercitos())){
            cambioCorrecto = true;
        }
        
        //si se puede realizar el cambio
        if (cambioCorrecto){
            setNumCambios(getNumCambios() + 1);
            //si es uno de sus primeros 5 cambios
            if (getNumCambios() < 6){
                setTropasGanadas((getNumCambios() * 2) + 2);
            }
            //si no lo es
            else{
                setTropasGanadas((getNumCambios() - 6) * 5 + 15);
            }
            
            //añadimos las tropas a la reserva
            setTropasReserva(tropasReserva + getTropasGanadas());
            
            //ahora comprobamos si el jugador tiene algun pais de las cartas
            //ya que si lo tiene se le regala 2 tropas mas en dicho territorio
            if ((car1.getPais() != null) && (car1.getPais().getPropietarioTer() == this)){
                car1.getPais().setNumEjercito(car1.getPais().getNumEjercito() + 2);
                //ademas las añadimos al total de tropas ganadas
                setTropasGanadas(getTropasGanadas() + 2);
            }
            if ((car2.getPais() != null) && (car2.getPais().getPropietarioTer() == this)){
                car2.getPais().setNumEjercito(car2.getPais().getNumEjercito() + 2);
                //ademas las añadimos al total de tropas ganadas
                setTropasGanadas(getTropasGanadas() + 2);
            }
            if ((car3.getPais() != null) && (car3.getPais().getPropietarioTer() == this)){
                car3.getPais().setNumEjercito(car3.getPais().getNumEjercito() + 2);
                //ademas las añadimos al total de tropas ganadas
                setTropasGanadas(getTropasGanadas() + 2);
            }
            
            
            //ahora eliminamos las cartas cambiadas de las cartas del jugador
            cartaTerritorio.remove(car1);
            cartaTerritorio.remove(car2);
            cartaTerritorio.remove(car3);
        }
        else tropasGanadas = 0;
        return cambioCorrecto;
        
    }

    //Metodo que ubica una tropa en el territorio pasado por parametro
    public boolean ubicarTropas(Territorio terr){
        //Comprobamos que el territorio pertenezca al jugador
        if (terr.getPropietarioTer().getColor() == this.getColor()){
            //Añadimos la tropa y la quitamos de la reserva
            terr.setNumEjercito(terr.getNumEjercito()+1);
            System.out.println("Tropas: "+terr.getNumEjercito());
            tropasReserva--;
            return true;
        }
        //si no pertenece al jugador devolvemos false
        return false;
    }
    
    
    //Metodo que mueve tropas entre el territorio origen y destino
    public boolean moverTropas(Territorio origen, Territorio destino, int tropas){
        int numTropas = tropas;
        
        //Comprobamos que ambos territorios sean contiguos
        for (int i = 0; origen.getTerritoriosAdy().get(i) != destino; i++){
            //Si ya hemos recorrido todos los adyacentes devolvemos falso
            if (i > origen.getTerritoriosAdy().size()) return false;
        }
        
        // Comprobamos si el origen tiene mas de una tropa y que haya bastante ejercito a mover
        if ((origen.getNumEjercito() > 1) && ((origen.getNumEjercito()) > numTropas)){
                //Quitar las tropas del origen y pasarselas al destino
                origen.setNumEjercito(origen.getNumEjercito()-numTropas);
                destino.setNumEjercito(destino.getNumEjercito()+numTropas);
                //Si sale bien, devolvemos true
                return true;
        }
        //Si algo de lo anterior no se cumple devolvemos false
        return false;
    }
    


    public int getTropasReserva() {
        return tropasReserva;
    }

    public void setTropasReserva(int tropasReserva) {
        this.tropasReserva = tropasReserva;
    }
    
    public boolean puedeMover(Territorio origen, Territorio destino){
        
        if (origen.getPropietarioTer() != this) return false;
        if (destino.getPropietarioTer() != this) return false;
        
        if (origen.getNumEjercito() < 2) return false;
        if (origen == destino) return false;
    
        //Comprobamos que ambos territorios sean contiguos
        int numAdy = origen.getTerritoriosAdy().size();
        for (int i = 0; i < numAdy; i++){
            if (origen.getTerritoriosAdy().get(i) == destino) return true;
        }
        
        return false;
    }

    
    public boolean puedeAtacar(Territorio origen, Territorio destino){
        
        //Comprobamos que ambos territorios tienen distinto dueño
        if(origen.getPropietarioTer() == destino.getPropietarioTer()){
            return false;            
        }
        
        //si no tiene al menos 2 ejercitos el atacante
        if (origen.getNumEjercito() < 2) return false;
        
        //Comprobamos que ambos territorios sean contiguos
        int numAdy = origen.getTerritoriosAdy().size();
        for (int i = 0; i < numAdy; i++){
            if (origen.getTerritoriosAdy().get(i) == destino) return true;
        }
        
        return false;
    }
        
    public void compararDados(Territorio origen, Territorio destino) {
        System.out.println(origen.getNombreTerritorio()+"  vs.  "+destino.getNombreTerritorio());
        ArrayList<Dado> dadoOponente = destino.getPropietarioTer().getDadoDef();
        
        ordenaDados(dadoAta);
        ordenaDados(dadoOponente);
        
        for (int i = 0; i < dadoAta.size(); i++) {
            if (i < dadoOponente.size()) {
                if (dadoAta.get(i).getValor() > dadoOponente.get(i).getValor()) {
                    System.out.println("Dado " + (i + 1) + ": " + dadoAta.get(i).getValor() + " - " + dadoOponente.get(i).getValor() + ". Gana ataque");
                    destino.setNumEjercito(destino.getNumEjercito() - 1);
                } else {
                    System.out.println("Dado " + (i + 1) + ": " + dadoAta.get(i).getValor() + " - " + dadoOponente.get(i).getValor() + ". Gana defensa");
                    origen.setNumEjercito(origen.getNumEjercito() - 1);
                }
            }
            else{
                System.out.println("Dado "+(i+1)+": "+dadoAta.get(i).getValor());
            }
        }
        
        //hemos conseguido quedarnos sin ningun ejercito en nuestro territorio,
        //el dueño del territorio atacado debe de ser el dueño del nuestro.
        if(origen.getNumEjercito() <= 0){
            origen.getPropietarioTer().getTerritorio().remove(origen);
            origen.setPropietarioTer(destino.getPropietarioTer());
            origen.setNumEjercito(1);
            destino.setNumEjercito(destino.getNumEjercito()-1);
            destino.getPropietarioTer().setTerritorio(origen);
        }
        
        //hemos conseguido que el territorio atacado se quede sin tropas ,
        //nos tenemos que hacer dueños del el.
        if(destino.getNumEjercito() <=0){
            destino.getPropietarioTer().getTerritorio().remove(destino);
            destino.setPropietarioTer(origen.getPropietarioTer());
            destino.setNumEjercito(dadoAta.size());
            origen.setNumEjercito(origen.getNumEjercito()-dadoAta.size());
            origen.getPropietarioTer().setTerritorio(destino);
        }
    }

    private void ordenaDados(ArrayList<Dado> d){
        Dado aux;
        for (int i = 0; i < d.size(); i++) {
            for (int j = i; j < d.size(); j++) {
                if (d.get(i).getValor() < d.get(j).getValor()) {
                    aux = d.get(j);
                    d.set(j, d.get(i));
                    d.set(i, aux);
                }
            }
        }
    }

    public void setTerritorio(Territorio ter) {
        territoriosJug.add(ter);
    }

    public ArrayList<Dado> getDadoDef() {
        return dadoDef;
    }

    public void setDadoDef(ArrayList<Dado> dadoDef) {
        this.dadoDef = dadoDef;
    }

    public ArrayList<Dado> getDadoAta() {
        return dadoAta;
    }

    public void setDadoAta(ArrayList<Dado> dadoAta) {
        this.dadoAta = dadoAta;
    }

    public ArrayList<Territorio> getCapitales() {
        return capitales;
    }

    public void setCapitales(ArrayList<Territorio> capitales) {
        this.capitales = capitales;
    }
    
    public void anadirCapital(Territorio capital){
        capitales.add(capital);
    }
    
    public void quitarCapital(Territorio capital){
        capitales.remove(capital);
    }

    public int getTropasGanadas() {
        return tropasGanadas;
    }

    public void setTropasGanadas(int tropasGanadas) {
        this.tropasGanadas = tropasGanadas;
    }

    public int getNumCambios() {
        return numCambios;
    }

    public void setNumCambios(int numCambios) {
        this.numCambios = numCambios;
    }

    public boolean isNeutral() {
        return neutral;
    }

    public void setNeutral(boolean neutral) {
        this.neutral = neutral;
    }

    public Dado getDadoComienzo() {
        return dadoComienzo;
    }

    public void setDadoComienzo(Dado dadoComienzo) {
        this.dadoComienzo = dadoComienzo;
    }
}

