/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package src;

import java.io.Serializable;
import java.util.Calendar;
import java.util.GregorianCalendar;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 *
 * @author fco.dominguez
 * @author juan.alvarez
 */

@Entity
public class PartidaEntidad implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    private int numJug;
    private String jugador1;
    private String jugador2;
    private String jugador3;
    private String jugador4;
    private String jugador5;
    private String jugador6;
    
    private int dia;
    private int mes;
    private int anio;
    private int hora;
    private int minutos;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public PartidaEntidad(){
        Calendar c = new GregorianCalendar();
        anio = c.get(Calendar.YEAR);
        dia = c.get(Calendar.DAY_OF_MONTH);
        hora = c.get(Calendar.HOUR_OF_DAY);
        mes = (c.get(Calendar.MONTH)+1);
        minutos = c.get(Calendar.MINUTE);
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PartidaEntidad)) {
            return false;
        }
        PartidaEntidad other = (PartidaEntidad) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        String dato = null;
        switch(numJug){
            case 2:
                dato = dia+"/"+mes+"/"+anio+" - "+hora+":"+minutos+"   J1: "+jugador1+"; J2: "+jugador2;
                break;
            case 3:
                dato = dia+"/"+mes+"/"+anio+"   J1: "+jugador1+"; J2: "+jugador2+"; J3: "+jugador3;
                break;
            case 4:
                dato = dia+"/"+mes+"/"+anio+"   J1: "+jugador1+"; J2: "+jugador2+"; J3: "+jugador3+"; J4: "+jugador4;
                break;
            case 5:
                dato = dia+"/"+mes+"/"+anio+"   J1: "+jugador1+"; J2: "+jugador2+"; J3: "+jugador3+"; J4: "+jugador4+"; J5: "+jugador5;
                break;
            case 6:
                dato = dia+"/"+mes+"/"+anio+"   J1: "+jugador1+"; J2: "+jugador2+"; J3: "+jugador3+"; J4: "+jugador4+"; J5: "+jugador5+"; J6: "+jugador6;
                break;
        }
        return dato;
    }
    
    public void setJugador1(String jugador1){
        this.jugador1 = jugador1;
    }
    
    public String getJugador1(){
        return this.jugador1;
    }
    
    public void setJugador2(String jugador2){
        this.jugador2 = jugador2;
    }
    
    public String getJugador2(){
        return this.jugador2;
    }
    
    public void setJugador3(String jugador3){
        this.jugador3 = jugador3;
    }
    
    public String getJugador3(){
        return this.jugador3;
    }
    
    public void setJugador4(String jugador4){
        this.jugador4 = jugador4;
    }
    
    public String getJugador4(){
        return this.jugador4;
    }
    
    public void setJugador5(String jugador5){
        this.jugador5 = jugador5;
    }
    
    public String getJugador5(){
        return this.jugador5;
    }
    
    public void setJugador6(String jugador6){
        this.jugador6 = jugador6;
    }
    
    public String getJugador6(){
        return this.jugador6;
    }
    
    public void setDia(int dia){
        this.dia = dia;
    }
    
    public int getDia(){
        return this.dia;
    }
    
    public void setMes(int mes){
        this.mes = mes;
    }
    
    public int getMes(){
        return this.mes;
    }
    
    public void setAnio(int anio){
        this.anio = anio;
    }
    
    public int getAnio(){
        return this.anio;
    }
    
    public void setHora(int hora){
        this.hora = hora;
    }
    
    public int getHora(){
        return this.hora;
    }
    
    public void setMinutos(int minutos){
        this.minutos = minutos;
    }
    
    public int getMinutos(){
        return this.minutos;
    }

    public int getNumJug() {
        return numJug;
    }

    public void setNumJug(int numJug) {
        this.numJug = numJug;
    }

}
